package cn.com.infosec.asn1.cms;

import cn.com.infosec.asn1.ASN1SequenceParser;
import cn.com.infosec.asn1.ASN1SetParser;
import cn.com.infosec.asn1.ASN1TaggedObjectParser;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERInteger;

public class EnvelopedDataParser {
   private ASN1SequenceParser _seq;
   private DERInteger _version;
   private DEREncodable _nextObject;
   private boolean _originatorInfoCalled;

   public EnvelopedDataParser(ASN1SequenceParser seq) {
      this._seq = seq;
      this._version = (DERInteger)seq.readObject();
   }

   public DERInteger getVersion() {
      return this._version;
   }

   public ASN1SetParser getCertificates() {
      if (this._nextObject == null) {
         this._nextObject = this._seq.readObject();
      }

      DEREncodable var1;
      if ((var1 = this._nextObject) instanceof ASN1TaggedObjectParser && ((ASN1TaggedObjectParser)var1).getTagNo() == 0) {
         ASN1SetParser var10000 = (ASN1SetParser)((ASN1TaggedObjectParser)this._nextObject).getObjectParser(17, false);
         this._nextObject = null;
         return var10000;
      } else {
         return null;
      }
   }

   public ASN1SetParser getCrls() {
      if (this._nextObject == null) {
         this._nextObject = this._seq.readObject();
      }

      DEREncodable var1;
      if ((var1 = this._nextObject) instanceof ASN1TaggedObjectParser && ((ASN1TaggedObjectParser)var1).getTagNo() == 1) {
         ASN1SetParser var10000 = (ASN1SetParser)((ASN1TaggedObjectParser)this._nextObject).getObjectParser(17, false);
         this._nextObject = null;
         return var10000;
      } else {
         return null;
      }
   }

   public OriginatorInfo getOriginatorInfo() {
      this._originatorInfoCalled = true;
      if (this._nextObject == null) {
         this._nextObject = this._seq.readObject();
      }

      DEREncodable var1;
      if ((var1 = this._nextObject) instanceof ASN1TaggedObjectParser && ((ASN1TaggedObjectParser)var1).getTagNo() == 0) {
         EnvelopedDataParser var10000 = this;
         ASN1SequenceParser var2 = (ASN1SequenceParser)((ASN1TaggedObjectParser)this._nextObject).getObjectParser(16, false);
         var10000._nextObject = null;
         return OriginatorInfo.getInstance(var2.getDERObject());
      } else {
         return null;
      }
   }

   public ASN1SetParser getRecipientInfos() {
      if (!this._originatorInfoCalled) {
         this.getOriginatorInfo();
      }

      if (this._nextObject == null) {
         this._nextObject = this._seq.readObject();
      }

      ASN1SetParser var10000 = (ASN1SetParser)this._nextObject;
      this._nextObject = null;
      return var10000;
   }

   public EncryptedContentInfoParser getEncryptedContentInfo() {
      if (this._nextObject == null) {
         this._nextObject = this._seq.readObject();
      }

      DEREncodable var1;
      if ((var1 = this._nextObject) != null) {
         EnvelopedDataParser var10000 = this;
         ASN1SequenceParser var2 = (ASN1SequenceParser)var1;
         var10000._nextObject = null;
         return new EncryptedContentInfoParser(var2);
      } else {
         return null;
      }
   }

   public ASN1SetParser getUnprotectedAttrs() {
      if (this._nextObject == null) {
         this._nextObject = this._seq.readObject();
      }

      DEREncodable var1;
      if ((var1 = this._nextObject) != null) {
         this._nextObject = null;
         return (ASN1SetParser)((ASN1TaggedObjectParser)var1).getObjectParser(17, false);
      } else {
         return null;
      }
   }
}
